﻿using System;
using NUnit.Framework;

namespace Bespoke.ResearchExpert.Data.Test
{
    public abstract class TestFixtureBase
    {
        public TestFixtureBase()
        {
            mDatabase = new Database();
        }

        [TestFixtureSetUp]
        public void TestFixtureSetup()
        {
            mDatabase.Init(true);

            OnTestFixtureSetup();
        }

        [TestFixtureTearDown]
        public void TestFixtureTearDown()
        {
            OnTestFixtureTearDown();

            mDatabase.Shutdown();
        }

        #region Protected Methods

        protected virtual void OnTestFixtureSetup()
        {
        }

        protected virtual void OnTestFixtureTearDown()
        {
        }

        #endregion

        protected Database mDatabase;
    }
}
