﻿using System;

namespace Bespoke.ResearchExpert.Data
{
    /// <summary>
    /// 
    /// </summary>
    [AttributeUsage(AttributeTargets.Class, AllowMultiple = false)]
    public class DataManagerAttribute : Attribute
    {
        /// <summary>
        /// Gets the init method.
        /// </summary>
        /// <value>The init method.</value>
        public string InitMethod
        {
            get
            {
                return mInitMethod;
            }
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="DataManagerAttribute"/> class.
        /// </summary>
        /// <param name="initMethod">The init method.</param>
        public DataManagerAttribute(string initMethod)
        {
            mInitMethod = initMethod;

        }

        private string mInitMethod;
    }
}
