﻿using System;
using System.Reflection;
using System.Collections.Generic;
using System.Text;
using Bespoke.Common;

namespace Bespoke.ResearchExpert.Data
{
    /// <summary>
    /// 
    /// </summary>
    public class DocumentKeywordLinkRecord
    {
        /// <summary>
        /// Gets or sets the document key.
        /// </summary>
        /// <value>The document key.</value>
        public int DocumentKey
        {
            get
            {
                return mDocumentKey;
            }
            set
            {
                mDocumentKey = value;
            }
        }

        /// <summary>
        /// Gets or sets the keyword key.
        /// </summary>
        /// <value>The keyword key.</value>
        public int KeywordKey
        {
            get
            {
                return mKeywordKey;
            }
            set
            {
                mKeywordKey = value;
            }
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="DocumentKeywordLink"/> class.
        /// </summary>
        public DocumentKeywordLinkRecord()
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="DocumentKeywordLink"/> class.
        /// </summary>
        /// <param name="documentKey">The documentKey.</param>
        /// <param name="keywordKey">The keywordKey.</param>
        public DocumentKeywordLinkRecord(int documentKey, int keywordKey)
        {
            mDocumentKey = documentKey;
            mKeywordKey = keywordKey;
        }

        /// <summary>
        /// Implements the operator ==.
        /// </summary>
        /// <param name="lhs">The LHS.</param>
        /// <param name="rhs">The RHS.</param>
        /// <returns>The result of the operator.</returns>
        public static bool operator ==(DocumentKeywordLinkRecord lhs, DocumentKeywordLinkRecord rhs)
        {
            return RecordUtility.Equals(lhs, rhs);
        }

        /// <summary>
        /// Implements the operator !=.
        /// </summary>
        /// <param name="lhs">The LHS.</param>
        /// <param name="rhs">The RHS.</param>
        /// <returns>The result of the operator.</returns>
        public static bool operator !=(DocumentKeywordLinkRecord lhs, DocumentKeywordLinkRecord rhs)
        {
            return !(lhs == rhs);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="other"></param>
        /// <returns></returns>
        public override bool Equals(object other)
        {
            if (!(other is DocumentKeywordLinkRecord))
            {
                return false;
            }

            return this == (DocumentKeywordLinkRecord)other;
        }

        private int mDocumentKey;
        private int mKeywordKey;
    }

    /// <summary>
    /// 
    /// </summary>
    public class DocumentKeywordLinkRecordList : List<DocumentKeywordLinkRecord> { }
}
