﻿using System;
using System.Reflection;
using System.Collections.Generic;
using System.Text;
using Bespoke.Common;

namespace Bespoke.ResearchExpert.Data
{
    /// <summary>
    /// 
    /// </summary>
    public class GroupRecord
    {
        public static readonly int KeySize = 4;
        public static readonly int NameSize = 60;

        /// <summary>
        /// Gets or sets the key.
        /// </summary>
        /// <value>The key.</value>
        public int Key
        {
            get
            {
                return mKey;
            }
            set
            {
                mKey = value;
            }
        }

        /// <summary>
        /// Gets or sets the user key.
        /// </summary>
        /// <value>The user key.</value>
        public int UserKey
        {
            get
            {
                return mUserKey;
            }
            set
            {
                mUserKey = value;
            }
        }

        /// <summary>
        /// Gets or sets the name.
        /// </summary>
        /// <value>The name.</value>
        public string Name
        {
            get
            {
                return mName;
            }
            set
            {
                mName = value;
            }
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="GroupRecord"/> class.
        /// </summary>
        public GroupRecord()
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="GroupRecord"/> class.
        /// </summary>
        /// <param name="key">The key.</param>
        /// <param name="userKey">The repository key.</param>
        /// <param name="name">The name.</param>
        public GroupRecord(int key, int userKey, string name)
        {
            mKey = key;
            mUserKey = userKey;
            mName = name;
        }

        /// <summary>
        /// Implements the operator ==.
        /// </summary>
        /// <param name="lhs">The LHS.</param>
        /// <param name="rhs">The RHS.</param>
        /// <returns>The result of the operator.</returns>
        public static bool operator ==(GroupRecord lhs, GroupRecord rhs)
        {
            return RecordUtility.Equals(lhs, rhs);
        }

        /// <summary>
        /// Implements the operator !=.
        /// </summary>
        /// <param name="lhs">The LHS.</param>
        /// <param name="rhs">The RHS.</param>
        /// <returns>The result of the operator.</returns>
        public static bool operator !=(GroupRecord lhs, GroupRecord rhs)
        {
            return !(lhs == rhs);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="other"></param>
        /// <returns></returns>
        public override bool Equals(object other)
        {
            if (!(other is GroupRecord))
            {
                return false;
            }

            return this == (GroupRecord)other;
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public override string ToString()
        {
            return mName;
        }

        private int mKey;
        private int mUserKey;
        private string mName;
    }

    /// <summary>
    /// 
    /// </summary>
    public class GroupRecordList : List<GroupRecord> { }
}
