﻿using System;
using System.Reflection;
using System.Collections.Generic;
using System.Text;
using Bespoke.Common;

namespace Bespoke.ResearchExpert.Data
{
    /// <summary>
    /// 
    /// </summary>
    public class KeywordRecord
    {
        public static readonly int KeySize = 4;
        public static readonly int WordSize = 50;

        /// <summary>
        /// Gets or sets the key.
        /// </summary>
        /// <value>The key.</value>
        public int Key
        {
            get
            {
                return mKey;
            }
            set
            {
                mKey = value;
            }
        }

        /// <summary>
        /// Gets or sets the word.
        /// </summary>
        /// <value>The word.</value>
        public string Word
        {
            get
            {
                return mWord;
            }
            set
            {
                mWord = value;
            }
        }      

        /// <summary>
        /// Initializes a new instance of the <see cref="KeywordRecord"/> class.
        /// </summary>
        public KeywordRecord()
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="KeywordRecord"/> class.
        /// </summary>
        /// <param name="key">The key.</param>
        /// <param name="word">The word.</param>
        public KeywordRecord(int key, string word)
        {
            mKey = key;
            mWord = word;
        }

        /// <summary>
        /// Implements the operator ==.
        /// </summary>
        /// <param name="lhs">The LHS.</param>
        /// <param name="rhs">The RHS.</param>
        /// <returns>The result of the operator.</returns>
        public static bool operator ==(KeywordRecord lhs, KeywordRecord rhs)
        {
            return RecordUtility.Equals(lhs, rhs);
        }

        /// <summary>
        /// Implements the operator !=.
        /// </summary>
        /// <param name="lhs">The LHS.</param>
        /// <param name="rhs">The RHS.</param>
        /// <returns>The result of the operator.</returns>
        public static bool operator !=(KeywordRecord lhs, KeywordRecord rhs)
        {
            return !(lhs == rhs);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="other"></param>
        /// <returns></returns>
        public override bool Equals(object other)
        {
            if (!(other is KeywordRecord))
            {
                return false;
            }

            return this == (KeywordRecord)other;
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public override string ToString()
        {
            return mWord;
        }

        private int mKey;
        private string mWord;
    }

    /// <summary>
    /// 
    /// </summary>
    public class KeywordRecordList : List<KeywordRecord> { }
}
