﻿using System;
using System.Reflection;
using System.Collections.Generic;
using System.Text;
using Bespoke.Common;

namespace Bespoke.ResearchExpert.Data
{
    /// <summary>
    /// 
    /// </summary>
    public class PublicationSourceRecord
    {
        public static readonly int KeySize = 4;
        public static readonly int NameSize = 60;

        /// <summary>
        /// Gets or sets the key.
        /// </summary>
        /// <value>The key.</value>
        public int Key
        {
            get
            {
                return mKey;
            }
            set
            {
                mKey = value;
            }
        }

        /// <summary>
        /// Gets or sets the name.
        /// </summary>
        /// <value>The name.</value>
        public string Name
        {
            get
            {
                return mName;
            }
            set
            {
                mName = value;
            }
        }

        /// <summary>
        /// Gets or sets the type key.
        /// </summary>
        /// <value>The type key.</value>
        public int TypeKey
        {
            get
            {
                return mTypeKey;
            }
            set
            {
                mTypeKey = value;
            }
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="PublicationSourceRecord"/> class.
        /// </summary>
        public PublicationSourceRecord()
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="PublicationSourceRecord"/> class.
        /// </summary>
        /// <param name="key">The key.</param>
        /// <param name="name">The name.</param>
        /// <param name="typeKey">The type key.</param>
        public PublicationSourceRecord(int key, string name, int typeKey)
        {
            mKey = key;
            mName = name;
            mTypeKey = typeKey;
        }

        /// <summary>
        /// Implements the operator ==.
        /// </summary>
        /// <param name="lhs">The LHS.</param>
        /// <param name="rhs">The RHS.</param>
        /// <returns>The result of the operator.</returns>
        public static bool operator ==(PublicationSourceRecord lhs, PublicationSourceRecord rhs)
        {
            return RecordUtility.Equals(lhs, rhs);
        }

        /// <summary>
        /// Implements the operator !=.
        /// </summary>
        /// <param name="lhs">The LHS.</param>
        /// <param name="rhs">The RHS.</param>
        /// <returns>The result of the operator.</returns>
        public static bool operator !=(PublicationSourceRecord lhs, PublicationSourceRecord rhs)
        {
            return !(lhs == rhs);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="other"></param>
        /// <returns></returns>
        public override bool Equals(object other)
        {
            if (!(other is PublicationSourceRecord))
            {
                return false;
            }

            return this == (PublicationSourceRecord)other;
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public override string ToString()
        {
            return mName;
        }

        private int mKey;
        private string mName;
        private int mTypeKey;
    }

    /// <summary>
    /// 
    /// </summary>
    public class PublicationSourceRecordList : List<PublicationSourceRecord> { }
}
