﻿using System;
using System.Reflection;
using System.Collections.Generic;
using System.Text;
using Bespoke.Common;

namespace Bespoke.ResearchExpert.Data
{
    /// <summary>
    /// 
    /// </summary>
    public class PublicationSourceTypeRecord
    {
        public static readonly int KeySize = 4;
        public static readonly int NameSize = 60;

        /// <summary>
        /// Gets or sets the key.
        /// </summary>
        /// <value>The key.</value>
        public int Key
        {
            get
            {
                return mKey;
            }
            set
            {
                mKey = value;
            }
        }

        /// <summary>
        /// Gets or sets the name.
        /// </summary>
        /// <value>The name.</value>
        public string Name
        {
            get
            {
                return mName;
            }
            set
            {
                mName = value;
            }
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="PublicationSourceTypeRecord"/> class.
        /// </summary>
        public PublicationSourceTypeRecord()
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="PublicationSourceTypeRecord"/> class.
        /// </summary>
        /// <param name="key">The key.</param>
        /// <param name="fullName">The full name.</param>
        /// <param name="affiliation">The affiliation.</param>
        public PublicationSourceTypeRecord(int key, string name)
        {
            mKey = key;
            mName = name;
        }

        /// <summary>
        /// Implements the operator ==.
        /// </summary>
        /// <param name="lhs">The LHS.</param>
        /// <param name="rhs">The RHS.</param>
        /// <returns>The result of the operator.</returns>
        public static bool operator ==(PublicationSourceTypeRecord lhs, PublicationSourceTypeRecord rhs)
        {
            return RecordUtility.Equals(lhs, rhs);
        }

        /// <summary>
        /// Implements the operator !=.
        /// </summary>
        /// <param name="lhs">The LHS.</param>
        /// <param name="rhs">The RHS.</param>
        /// <returns>The result of the operator.</returns>
        public static bool operator !=(PublicationSourceTypeRecord lhs, PublicationSourceTypeRecord rhs)
        {
            return !(lhs == rhs);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="other"></param>
        /// <returns></returns>
        public override bool Equals(object other)
        {
            if (!(other is PublicationSourceTypeRecord))
            {
                return false;
            }

            return this == (PublicationSourceTypeRecord)other;
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public override string ToString()
        {
            return mName;
        }

        private int mKey;
        private string mName;
    }

    /// <summary>
    /// 
    /// </summary>
    public class PublicationSourceTypeRecordList : List<PublicationSourceTypeRecord> { }
}
