﻿using System;
using System.Reflection;
using System.Collections.Generic;
using System.Text;
using Bespoke.Common;

namespace Bespoke.ResearchExpert.Data
{
    /// <summary>
    /// 
    /// </summary>
    public class RepositoryGroupLinkRecord
    {
        /// <summary>
        /// Gets or sets the repository key.
        /// </summary>
        /// <value>The repository key.</value>
        public int RepositoryKey
        {
            get
            {
                return mRepositoryKey;
            }
            set
            {
                mRepositoryKey = value;
            }
        }

        /// <summary>
        /// Gets or sets the group key.
        /// </summary>
        /// <value>The group key.</value>
        public int GroupKey
        {
            get
            {
                return mGroupKey;
            }
            set
            {
                mGroupKey = value;
            }
        }

        /// <summary>
        /// Gets or sets the role key.
        /// </summary>
        /// <value>The role key.</value>
        public int RoleKey
        {
            get
            {
                return mRoleKey;
            }
            set
            {
                mRoleKey = value;
            }
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="RepositoryGroupLinkRecord"/> class.
        /// </summary>
        public RepositoryGroupLinkRecord()
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="RepositoryGroupLinkRecord"/> class.
        /// </summary>
        /// <param name="repositoryKey">The repositoryKey.</param>
        /// <param name="groupKey">The groupKey.</param>
        /// <param name="roleKey">The roleKey.</param>
        public RepositoryGroupLinkRecord(int repositoryKey, int groupKey, int roleKey)
        {
            mRepositoryKey = repositoryKey;
            mGroupKey = groupKey;
            mRoleKey = roleKey;
        }

        /// <summary>
        /// Implements the operator ==.
        /// </summary>
        /// <param name="lhs">The LHS.</param>
        /// <param name="rhs">The RHS.</param>
        /// <returns>The result of the operator.</returns>
        public static bool operator ==(RepositoryGroupLinkRecord lhs, RepositoryGroupLinkRecord rhs)
        {
            return RecordUtility.Equals(lhs, rhs);
        }

        /// <summary>
        /// Implements the operator !=.
        /// </summary>
        /// <param name="lhs">The LHS.</param>
        /// <param name="rhs">The RHS.</param>
        /// <returns>The result of the operator.</returns>
        public static bool operator !=(RepositoryGroupLinkRecord lhs, RepositoryGroupLinkRecord rhs)
        {
            return !(lhs == rhs);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="other"></param>
        /// <returns></returns>
        public override bool Equals(object other)
        {
            if (!(other is RepositoryGroupLinkRecord))
            {
                return false;
            }

            return this == (RepositoryGroupLinkRecord)other;
        }

        private int mRepositoryKey;
        private int mGroupKey;
        private int mRoleKey;
    }

    /// <summary>
    /// 
    /// </summary>
    public class RepositoryGroupLinkRecordList : List<RepositoryGroupLinkRecord> { }
}
