﻿using System;
using System.Reflection;
using System.Collections.Generic;
using System.Text;
using Bespoke.Common;

namespace Bespoke.ResearchExpert.Data
{
    /// <summary>
    /// 
    /// </summary>
    public class RepositoryUserLinkRecord
    {
        /// <summary>
        /// Gets or sets the repository key.
        /// </summary>
        /// <value>The repository key.</value>
        public int RepositoryKey
        {
            get
            {
                return mRepositoryKey;
            }
            set
            {
                mRepositoryKey = value;
            }
        }

        /// <summary>
        /// Gets or sets the user key.
        /// </summary>
        /// <value>The user key.</value>
        public int UserKey
        {
            get
            {
                return mUserKey;
            }
            set
            {
                mUserKey = value;
            }
        }

        /// <summary>
        /// Gets or sets the role key.
        /// </summary>
        /// <value>The role key.</value>
        public int RoleKey
        {
            get
            {
                return mRoleKey;
            }
            set
            {
                mRoleKey = value;
            }
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="RepositoryUserLinkRecord"/> class.
        /// </summary>
        public RepositoryUserLinkRecord()
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="RepositoryUserLinkRecord"/> class.
        /// </summary>
        /// <param name="repositoryKey">The repositoryKey.</param>
        /// <param name="userKey">The userKey.</param>
        /// <param name="roleKey">The roleKey.</param>
        public RepositoryUserLinkRecord(int repositoryKey, int userKey, int roleKey)
        {
            mRepositoryKey = repositoryKey;
            mUserKey = userKey;
            mRoleKey = roleKey;
        }

        /// <summary>
        /// Implements the operator ==.
        /// </summary>
        /// <param name="lhs">The LHS.</param>
        /// <param name="rhs">The RHS.</param>
        /// <returns>The result of the operator.</returns>
        public static bool operator ==(RepositoryUserLinkRecord lhs, RepositoryUserLinkRecord rhs)
        {
            return RecordUtility.Equals(lhs, rhs);
        }

        /// <summary>
        /// Implements the operator !=.
        /// </summary>
        /// <param name="lhs">The LHS.</param>
        /// <param name="rhs">The RHS.</param>
        /// <returns>The result of the operator.</returns>
        public static bool operator !=(RepositoryUserLinkRecord lhs, RepositoryUserLinkRecord rhs)
        {
            return !(lhs == rhs);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="other"></param>
        /// <returns></returns>
        public override bool Equals(object other)
        {
            if (!(other is RepositoryUserLinkRecord))
            {
                return false;
            }

            return this == (RepositoryUserLinkRecord)other;
        }

        private int mRepositoryKey;
        private int mUserKey;
        private int mRoleKey;
    }

    /// <summary>
    /// 
    /// </summary>
    public class RepositoryUserLinkRecordList : List<RepositoryUserLinkRecord> { }
}
