﻿using System;
using System.Reflection;
using System.Collections.Generic;
using System.Text;
using Bespoke.Common;

namespace Bespoke.ResearchExpert.Data
{
    /// <summary>
    /// 
    /// </summary>
    public class UserGroupLinkRecord
    {
        /// <summary>
        /// Gets or sets the user userKey.
        /// </summary>
        /// <value>The user userKey.</value>
        public int UserKey
        {
            get
            {
                return mUserKey;
            }
            set
            {
                mUserKey = value;
            }
        }

        /// <summary>
        /// Gets or sets the group userKey.
        /// </summary>
        /// <value>The group userKey.</value>
        public int GroupKey
        {
            get
            {
                return mGroupKey;
            }
            set
            {
                mGroupKey = value;
            }
        }

        /// <summary>
        /// Gets or sets the role userKey.
        /// </summary>
        /// <value>The role userKey.</value>
        public int RoleKey
        {
            get
            {
                return mRoleKey;
            }
            set
            {
                mRoleKey = value;
            }
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="UserGroupLinkRecord"/> class.
        /// </summary>
        public UserGroupLinkRecord()
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="UserGroupLinkRecord"/> class.
        /// </summary>
        /// <param name="userKey">The userKey.</param>
        /// <param name="groupKey">The groupKey.</param>
        /// <param name="roleKey">The roleKey.</param>
        public UserGroupLinkRecord(int userKey, int groupKey, int roleKey)
        {
            mUserKey = userKey;
            mGroupKey = groupKey;
            mRoleKey = roleKey;
        }

        /// <summary>
        /// Implements the operator ==.
        /// </summary>
        /// <param name="lhs">The LHS.</param>
        /// <param name="rhs">The RHS.</param>
        /// <returns>The result of the operator.</returns>
        public static bool operator ==(UserGroupLinkRecord lhs, UserGroupLinkRecord rhs)
        {
            return RecordUtility.Equals(lhs, rhs);
        }

        /// <summary>
        /// Implements the operator !=.
        /// </summary>
        /// <param name="lhs">The LHS.</param>
        /// <param name="rhs">The RHS.</param>
        /// <returns>The result of the operator.</returns>
        public static bool operator !=(UserGroupLinkRecord lhs, UserGroupLinkRecord rhs)
        {
            return !(lhs == rhs);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="other"></param>
        /// <returns></returns>
        public override bool Equals(object other)
        {
            if (!(other is UserGroupLinkRecord))
            {
                return false;
            }

            return this == (UserGroupLinkRecord)other;
        }

        private int mUserKey;
        private int mGroupKey;
        private int mRoleKey;
    }

    /// <summary>
    /// 
    /// </summary>
    public class UserGroupLinkRecordList : List<UserGroupLinkRecord> { }
}
