ALTER TABLE [dbo].[Document]  WITH CHECK ADD  CONSTRAINT [FK_Document_Author] FOREIGN KEY ([AuthorKey])
REFERENCES [dbo].[Author] ([Key])
GO
ALTER TABLE [dbo].[Document] CHECK CONSTRAINT [FK_Document_Author]
GO

ALTER TABLE [dbo].[DocumentKeywordLink]  WITH CHECK ADD  CONSTRAINT [FK_DocumentKeywordLink_Document] FOREIGN KEY([DocumentKey])
REFERENCES [dbo].[Document] ([Key])
GO
ALTER TABLE [dbo].[DocumentKeywordLink] CHECK CONSTRAINT [FK_DocumentKeywordLink_Document]
GO

ALTER TABLE [dbo].[DocumentKeywordLink]  WITH CHECK ADD  CONSTRAINT [FK_DocumentKeywordLink_Keyword] FOREIGN KEY([KeywordKey])
REFERENCES [dbo].[Keyword] ([Key])
GO
ALTER TABLE [dbo].[DocumentKeywordLink] CHECK CONSTRAINT [FK_DocumentKeywordLink_Keyword]

ALTER TABLE [dbo].[Group]  WITH CHECK ADD  CONSTRAINT [FK_Group_User] FOREIGN KEY([UserKey])
REFERENCES [dbo].[User] ([Key])
GO
ALTER TABLE [dbo].[Group] CHECK CONSTRAINT [FK_Group_User]
GO

ALTER TABLE [dbo].[Document]  WITH CHECK ADD  CONSTRAINT [FK_Document_DocumentType] FOREIGN KEY([DocumentTypeKey])
REFERENCES [dbo].[DocumentType] ([Key])
GO
ALTER TABLE [dbo].[Document] CHECK CONSTRAINT [FK_Document_DocumentType]
GO

ALTER TABLE [dbo].[Document]  WITH CHECK ADD  CONSTRAINT [FK_Document_PublicationSource] FOREIGN KEY([PublicationSourceKey])
REFERENCES [dbo].[PublicationSource] ([Key])
GO
ALTER TABLE [dbo].[Document] CHECK CONSTRAINT [FK_Document_PublicationSource]
GO

ALTER TABLE [dbo].[Document]  WITH CHECK ADD  CONSTRAINT [FK_Document_Repository] FOREIGN KEY([RepositoryKey])
REFERENCES [dbo].[Repository] ([Key])
GO
ALTER TABLE [dbo].[Document] CHECK CONSTRAINT [FK_Document_Repository]
GO

ALTER TABLE [dbo].[PublicationSource]  WITH CHECK ADD  CONSTRAINT [FK_PublicationSource_PublicationSourceType] FOREIGN KEY([TypeKey])
REFERENCES [dbo].[PublicationSourceType] ([Key])
GO
ALTER TABLE [dbo].[PublicationSource] CHECK CONSTRAINT [FK_PublicationSource_PublicationSourceType]
GO

ALTER TABLE [dbo].[RepositoryUserLink]  WITH CHECK ADD  CONSTRAINT [FK_RepositoryUserLink_Repository] FOREIGN KEY([RepositoryKey])
REFERENCES [dbo].[Repository] ([Key])
GO
ALTER TABLE [dbo].[RepositoryUserLink] CHECK CONSTRAINT [FK_RepositoryUserLink_Repository]
GO

ALTER TABLE [dbo].[RepositoryUserLink]  WITH CHECK ADD  CONSTRAINT [FK_RepositoryUserLink_Role] FOREIGN KEY([RoleKey])
REFERENCES [dbo].[Role] ([Key])
GO
ALTER TABLE [dbo].[RepositoryUserLink] CHECK CONSTRAINT [FK_RepositoryUserLink_Role]
GO

ALTER TABLE [dbo].[RepositoryUserLink]  WITH CHECK ADD  CONSTRAINT [FK_RepositoryUserLink_User] FOREIGN KEY([UserKey])
REFERENCES [dbo].[User] ([Key])
GO
ALTER TABLE [dbo].[RepositoryUserLink] CHECK CONSTRAINT [FK_RepositoryUserLink_User]
GO

ALTER TABLE [dbo].[RepositoryGroupLink]  WITH CHECK ADD  CONSTRAINT [FK_RepositoryGroupLink_Group] FOREIGN KEY([GroupKey])
REFERENCES [dbo].[Group] ([Key])
GO
ALTER TABLE [dbo].[RepositoryGroupLink] CHECK CONSTRAINT [FK_RepositoryGroupLink_Group]
GO

ALTER TABLE [dbo].[RepositoryGroupLink]  WITH CHECK ADD  CONSTRAINT [FK_RepositoryGroupLink_Repository] FOREIGN KEY([RepositoryKey])
REFERENCES [dbo].[Repository] ([Key])
GO
ALTER TABLE [dbo].[RepositoryGroupLink] CHECK CONSTRAINT [FK_RepositoryGroupLink_Repository]
GO

ALTER TABLE [dbo].[RepositoryGroupLink]  WITH CHECK ADD  CONSTRAINT [FK_RepositoryGroupLink_Role] FOREIGN KEY([RoleKey])
REFERENCES [dbo].[Role] ([Key])
GO
ALTER TABLE [dbo].[RepositoryGroupLink] CHECK CONSTRAINT [FK_RepositoryGroupLink_Role]
GO

ALTER TABLE [dbo].[UserGroupLink]  WITH CHECK ADD  CONSTRAINT [FK_UserGroupLink_Group] FOREIGN KEY([GroupKey])
REFERENCES [dbo].[Group] ([Key])
GO
ALTER TABLE [dbo].[UserGroupLink] CHECK CONSTRAINT [FK_UserGroupLink_Group]
GO

ALTER TABLE [dbo].[UserGroupLink]  WITH CHECK ADD  CONSTRAINT [FK_UserGroupLink_Role] FOREIGN KEY([RoleKey])
REFERENCES [dbo].[Role] ([Key])
GO
ALTER TABLE [dbo].[UserGroupLink] CHECK CONSTRAINT [FK_UserGroupLink_Role]
GO

ALTER TABLE [dbo].[UserGroupLink]  WITH CHECK ADD  CONSTRAINT [FK_UserGroupLink_User] FOREIGN KEY([UserKey])
REFERENCES [dbo].[User] ([Key])
GO
ALTER TABLE [dbo].[UserGroupLink] CHECK CONSTRAINT [FK_UserGroupLink_User]
GO

ALTER TABLE [dbo].[Repository]  WITH CHECK ADD  CONSTRAINT [FK_Repository_User] FOREIGN KEY([UserKey])
REFERENCES [dbo].[User] ([Key])
GO
ALTER TABLE [dbo].[Repository] CHECK CONSTRAINT [FK_Repository_User]
GO

ALTER TABLE [dbo].[Review]  WITH CHECK ADD  CONSTRAINT [FK_Review_Document] FOREIGN KEY([DocumentKey])
REFERENCES [dbo].[Document] ([Key])
GO
ALTER TABLE [dbo].[Review] CHECK CONSTRAINT [FK_Review_Document]
GO

ALTER TABLE [dbo].[Review]  WITH CHECK ADD  CONSTRAINT [FK_Review_User] FOREIGN KEY([UserKey])
REFERENCES [dbo].[User] ([Key])
GO
ALTER TABLE [dbo].[Review] CHECK CONSTRAINT [FK_Review_User]
GO