-- Author
CREATE NONCLUSTERED INDEX [IX_Author] ON [dbo].[Author] 
(
	[FullName] ASC
)WITH (PAD_INDEX  = OFF, IGNORE_DUP_KEY = OFF) ON [PRIMARY]
GO

CREATE NONCLUSTERED INDEX [IX_Author_1] ON [dbo].[Author] 
(
	[Affiliation] ASC
)WITH (PAD_INDEX  = OFF, IGNORE_DUP_KEY = OFF) ON [PRIMARY]
GO

-- Document
CREATE NONCLUSTERED INDEX [IX_Document] ON [dbo].[Document] 
(
	[DocumentTypeKey] ASC
)WITH (PAD_INDEX  = OFF, IGNORE_DUP_KEY = OFF) ON [PRIMARY]
GO

CREATE NONCLUSTERED INDEX [IX_Document_1] ON [dbo].[Document] 
(
	[PublicationSourceKey] ASC
)WITH (PAD_INDEX  = OFF, IGNORE_DUP_KEY = OFF) ON [PRIMARY]
GO

CREATE NONCLUSTERED INDEX [IX_Document_2] ON [dbo].[Document] 
(
	[RepositoryKey] ASC
)WITH (PAD_INDEX  = OFF, IGNORE_DUP_KEY = OFF) ON [PRIMARY]
GO

CREATE NONCLUSTERED INDEX [IX_Document_3] ON [dbo].[Document] 
(
	[Title] ASC
)WITH (PAD_INDEX  = OFF, IGNORE_DUP_KEY = OFF) ON [PRIMARY]
GO

CREATE NONCLUSTERED INDEX [IX_Document_4] ON [dbo].[Document] 
(
	[PublicationDate] ASC
)WITH (PAD_INDEX  = OFF, IGNORE_DUP_KEY = OFF) ON [PRIMARY]
GO

-- DocumentType
CREATE UNIQUE NONCLUSTERED INDEX [IX_DocumentType] ON [dbo].[DocumentType] 
(
	[Name] ASC
)WITH (PAD_INDEX  = OFF, IGNORE_DUP_KEY = OFF) ON [PRIMARY]
GO

-- Group
CREATE UNIQUE NONCLUSTERED INDEX [IX_Group] ON [dbo].[Group] 
(
	[Name] ASC,
	[UserKey] ASC
)WITH (PAD_INDEX  = OFF, IGNORE_DUP_KEY = OFF) ON [PRIMARY]
GO

-- Keyword
CREATE UNIQUE CLUSTERED INDEX [IX_Keyword] ON [dbo].[Keyword] 
(
	[Word] ASC
)WITH (PAD_INDEX  = OFF, IGNORE_DUP_KEY = OFF) ON [PRIMARY]

-- PublicationSource
CREATE UNIQUE NONCLUSTERED INDEX [IX_PublicationSource] ON [dbo].[PublicationSource] 
(
	[Name] ASC,
	[TypeKey] ASC
)WITH (PAD_INDEX  = OFF, IGNORE_DUP_KEY = OFF) ON [PRIMARY]
GO

-- PublicationSourceType
CREATE UNIQUE NONCLUSTERED INDEX [IX_PublicationSourceType] ON [dbo].[PublicationSourceType] 
(
	[Name] ASC
)WITH (PAD_INDEX  = OFF, IGNORE_DUP_KEY = OFF) ON [PRIMARY]
GO

-- Repository
CREATE UNIQUE NONCLUSTERED INDEX [IX_Repository] ON [dbo].[Repository] 
(
	[UserKey] ASC,
	[Name] ASC
)WITH (PAD_INDEX  = OFF, IGNORE_DUP_KEY = OFF) ON [PRIMARY]
GO

-- RepositoryGroupLink
CREATE NONCLUSTERED INDEX [IX_RepositoryGroupLink] ON [dbo].[RepositoryGroupLink] 
(
	[RoleKey] ASC
)WITH (PAD_INDEX  = OFF, IGNORE_DUP_KEY = OFF) ON [PRIMARY]
GO

-- RepositoryUserLink
CREATE NONCLUSTERED INDEX [IX_RepositoryUserLink] ON [dbo].[RepositoryUserLink] 
(
	[UserKey] ASC
)WITH (PAD_INDEX  = OFF, IGNORE_DUP_KEY = OFF) ON [PRIMARY]
GO

-- Review
CREATE NONCLUSTERED INDEX [IX_Review] ON [dbo].[Review] 
(
	[DocumentKey] ASC
)WITH (PAD_INDEX  = OFF, IGNORE_DUP_KEY = OFF) ON [PRIMARY]
GO

CREATE NONCLUSTERED INDEX [IX_Review_1] ON [dbo].[Review] 
(
	[UserKey] ASC
)WITH (PAD_INDEX  = OFF, IGNORE_DUP_KEY = OFF) ON [PRIMARY]
GO

CREATE NONCLUSTERED INDEX [IX_Review_2] ON [dbo].[Review] 
(
	[Rating] ASC
)WITH (PAD_INDEX  = OFF, IGNORE_DUP_KEY = OFF) ON [PRIMARY]
GO

-- Role
CREATE UNIQUE NONCLUSTERED INDEX [IX_Role] ON [dbo].[Role] 
(
	[Name] ASC
)WITH (PAD_INDEX  = OFF, IGNORE_DUP_KEY = OFF) ON [PRIMARY]
GO

-- User
CREATE UNIQUE NONCLUSTERED INDEX [IX_User] ON [dbo].[User] 
(
	[Username] ASC
)WITH (PAD_INDEX  = OFF, IGNORE_DUP_KEY = OFF) ON [PRIMARY]
GO

CREATE NONCLUSTERED INDEX [IX_User_1] ON [dbo].[User] 
(
	[Username] ASC
)WITH (PAD_INDEX  = OFF, IGNORE_DUP_KEY = OFF) ON [PRIMARY]
GO

-- UserGroupLink
CREATE NONCLUSTERED INDEX [IX_UserGroupLink] ON [dbo].[UserGroupLink] 
(
	[RoleKey] ASC
)WITH (PAD_INDEX  = OFF, IGNORE_DUP_KEY = OFF) ON [PRIMARY]
GO