CREATE PROCEDURE [dbo].AddAuthor (
	@FullName varchar(60),
	@Affiliation varchar(60)
)
AS

INSERT INTO Author (
	FullName,
	Affiliation
)
VALUES (
	@FullName,
	@Affiliation
)

RETURN @@IDENTITY
GO

CREATE PROCEDURE [dbo].DeleteAuthor (
	@Key int
)
AS

DELETE FROM Author
WHERE [Key] = @Key

IF @@ROWCOUNT = 0
	RETURN 0
ELSE
	RETURN 1
GO

CREATE PROCEDURE [dbo].RetrieveAuthorByKey (
	@Key int
)
AS

SELECT
	[Key],
	FullName,
	Affiliation
FROM Author
WHERE [Key] = @Key

IF @@ROWCOUNT = 0
	RETURN 0
ELSE
	RETURN 1
GO

CREATE PROCEDURE [dbo].RetrieveAuthorByFullName (
	@FullName varchar(60)
)
AS

SELECT
	[Key],
	FullName,
	Affiliation
FROM Author
WHERE FullName = @FullName

IF @@ROWCOUNT = 0
	RETURN 0
ELSE
	RETURN 1
GO

CREATE PROCEDURE [dbo].LoadAuthor
AS

SELECT
	[Key],
	FullName,
	Affiliation
FROM Author
ORDER BY FullName
GO

CREATE PROCEDURE [dbo].UpdateAuthor (
	@Key int,
	@FullName varchar(60),
	@Affiliation varchar(60)
)
AS

UPDATE Author
SET	FullName = @FullName,
	Affiliation = @Affiliation
WHERE [Key] = @Key

IF @@ROWCOUNT = 0
	RETURN 0
ELSE
	RETURN 1
GO
