CREATE PROCEDURE [dbo].AddGroup (
	@UserKey int,
	@Name varchar(255)
)
AS

INSERT INTO [Group] (
	UserKey,
	[Name]
)
VALUES (
	@UserKey,
	@Name
)

RETURN @@IDENTITY
GO

CREATE PROCEDURE [dbo].DeleteGroup (
	@Key int
)
AS

DELETE FROM [Group]
WHERE [Key] = @Key

IF @@ROWCOUNT = 0
	RETURN 0
ELSE
	RETURN 1
GO

CREATE PROCEDURE [dbo].RetrieveGroupByKey (
	@Key int
)
AS

SELECT
	[Key],
	UserKey,
	[Name]
FROM [Group]
WHERE [Key] = @Key

IF @@ROWCOUNT = 0
	RETURN 0
ELSE
	RETURN 1
GO

CREATE PROCEDURE [dbo].RetrieveGroupByName (
	@UserKey int,
	@Name varchar(255)
)
AS

SELECT
	[Key],
	UserKey,
	[Name]
FROM [Group]
WHERE UserKey = @UserKey AND [Name] = @Name

IF @@ROWCOUNT = 0
	RETURN 0
ELSE
	RETURN 1
GO

CREATE PROCEDURE [dbo].LoadGroup
AS

SELECT
	[Key],
	UserKey,
	[Name]
FROM [Group]
ORDER BY [Name]
GO

CREATE PROCEDURE [dbo].LoadGroupByUserKey (
	@UserKey int
)
AS

SELECT
	[Key],
	UserKey,
	[Name]
FROM [Group]
ORDER BY UserKey, [Name]
GO

CREATE PROCEDURE [dbo].UpdateGroup (
	@Key int,
	@UserKey int,
	@Name varchar(255)
)
AS

UPDATE [Group]
SET	UserKey = @UserKey,
	[Name] = @Name
WHERE [Key] = @Key

IF @@ROWCOUNT = 0
	RETURN 0
ELSE
	RETURN 1
GO
