CREATE PROCEDURE [dbo].AddKeyword (
	@Word varchar(50)
)
AS

INSERT INTO Keyword (
	Word
)
VALUES (
	@Word
)

RETURN @@IDENTITY
GO

CREATE PROCEDURE [dbo].CreateKeyword (
	@Word varchar(50)
)
AS

DECLARE @Key int

IF EXISTS (SELECT [Key] FROM Keyword WHERE Word = @Word)
	BEGIN
		SELECT @Key = [Key] FROM Keyword WHERE Word = @Word
	END
ELSE	
	BEGIN
		INSERT INTO Keyword (
			Word
		)
		VALUES (
			@Word
		)

		SET @Key = @@IDENTITY
	END	
	
RETURN @Key	
GO

CREATE PROCEDURE [dbo].DeleteKeyword (
	@Key int
)
AS

DELETE FROM DocumentKeywordLink
WHERE KeywordKey = @Key

DELETE FROM Keyword
WHERE [Key] = @Key

IF @@ROWCOUNT = 0
	RETURN 0
ELSE
	RETURN 1
GO

CREATE PROCEDURE [dbo].RetrieveKeywordByKey (
	@Key int
)
AS

SELECT
	[Key],
	Word
FROM Keyword
WHERE [Key] = @Key

IF @@ROWCOUNT = 0
	RETURN 0
ELSE
	RETURN 1
GO

CREATE PROCEDURE [dbo].RetrieveKeywordByWord (
	@Word varchar(50)
)
AS

SELECT
	[Key],
	Word
FROM Keyword
WHERE Word = @Word

IF @@ROWCOUNT = 0
	RETURN 0
ELSE
	RETURN 1
GO

CREATE PROCEDURE [dbo].LoadKeyword
AS

SELECT
	[Key],
	Word
FROM Keyword
ORDER BY Word
GO

CREATE PROCEDURE [dbo].UpdateKeyword (
	@Key int,
	@Word varchar(50)
)
AS

UPDATE Keyword
SET	Word = @Word
WHERE [Key] = @Key

IF @@ROWCOUNT = 0
	RETURN 0
ELSE
	RETURN 1
GO
