CREATE PROCEDURE [dbo].AddPublicationSource (
	@Name varchar(60),
	@TypeKey int
)
AS

INSERT INTO PublicationSource (
	[Name],
	TypeKey
)
VALUES (
	@Name,
	@TypeKey
)

RETURN @@IDENTITY
GO

CREATE PROCEDURE [dbo].DeletePublicationSource (
	@Key int
)
AS

DELETE FROM PublicationSource
WHERE [Key] = @Key

IF @@ROWCOUNT = 0
	RETURN 0
ELSE
	RETURN 1
GO

CREATE PROCEDURE [dbo].RetrievePublicationSourceByKey (
	@Key int
)
AS

SELECT
	[Key],
	[Name],
	TypeKey
FROM PublicationSource
WHERE [Key] = @Key

IF @@ROWCOUNT = 0
	RETURN 0
ELSE
	RETURN 1
GO

CREATE PROCEDURE [dbo].RetrievePublicationSourceByName (
	@Name varchar(60)
)
AS

SELECT
	[Key],
	[Name],
	TypeKey
FROM PublicationSource
WHERE Name = @Name

IF @@ROWCOUNT = 0
	RETURN 0
ELSE
	RETURN 1
GO

CREATE PROCEDURE [dbo].LoadPublicationSource
AS

SELECT
	[Key],
	[Name],
	TypeKey
FROM PublicationSource
ORDER BY Name
GO

CREATE PROCEDURE [dbo].LoadPublicationSourceByTypeKey (
	@TypeKey int
)
AS

SELECT
	[Key],
	[Name],
	TypeKey
FROM PublicationSource
WHERE TypeKey = @TypeKey
ORDER BY Name
GO

CREATE PROCEDURE [dbo].UpdatePublicationSource (
	@Key int,
	@Name varchar(60),
	@TypeKey int
)
AS

UPDATE PublicationSource
SET	[Name] = @Name,
	TypeKey = @TypeKey
WHERE [Key] = @Key

IF @@ROWCOUNT = 0
	RETURN 0
ELSE
	RETURN 1
GO
