CREATE PROCEDURE [dbo].AddPublicationSourceType (
	@Name varchar(60)
)
AS

INSERT INTO PublicationSourceType (
	[Name]
)
VALUES (
	@Name
)

RETURN @@IDENTITY
GO

CREATE PROCEDURE [dbo].DeletePublicationSourceType (
	@Key int
)
AS

DELETE FROM PublicationSourceType
WHERE [Key] = @Key

IF @@ROWCOUNT = 0
	RETURN 0
ELSE
	RETURN 1
GO

CREATE PROCEDURE [dbo].RetrievePublicationSourceTypeByKey (
	@Key int
)
AS

SELECT
	[Key],
	[Name]
FROM PublicationSourceType
WHERE [Key] = @Key

IF @@ROWCOUNT = 0
	RETURN 0
ELSE
	RETURN 1
GO

CREATE PROCEDURE [dbo].RetrievePublicationSourceTypeByName (
	@Name varchar(60)
)
AS

SELECT
	[Key],
	[Name]
FROM PublicationSourceType
WHERE [Name] = @Name

IF @@ROWCOUNT = 0
	RETURN 0
ELSE
	RETURN 1
GO

CREATE PROCEDURE [dbo].LoadPublicationSourceType
AS

SELECT
	[Key],
	[Name]
FROM PublicationSourceType
ORDER BY Name
GO

CREATE PROCEDURE [dbo].UpdatePublicationSourceType (
	@Key int,
	@Name varchar(60)
)
AS

UPDATE PublicationSourceType
SET	[Name] = @Name	
WHERE [Key] = @Key

IF @@ROWCOUNT = 0
	RETURN 0
ELSE
	RETURN 1
GO
