CREATE PROCEDURE [dbo].AddRepositoryGroupLink (
	@RepositoryKey int,
	@GroupKey int,
	@RoleKey int
)
AS

INSERT INTO RepositoryGroupLink (
	RepositoryKey,
	GroupKey,
	RoleKey
)
VALUES (
	@RepositoryKey,
	@GroupKey,
	@RoleKey
)

GO

CREATE PROCEDURE [dbo].DeleteRepositoryGroupLink (
	@RepositoryKey int,
	@GroupKey int
)
AS

DELETE FROM RepositoryGroupLink
WHERE RepositoryKey = @RepositoryKey AND GroupKey = @GroupKey

IF @@ROWCOUNT = 0
	RETURN 0
ELSE
	RETURN 1
GO

CREATE PROCEDURE [dbo].RetrieveRepositoryGroupLinkByKey (
	@RepositoryKey int,
	@GroupKey int
)
AS

SELECT
	RepositoryKey,
	GroupKey,
	RoleKey
FROM RepositoryGroupLink
WHERE RepositoryKey = @RepositoryKey AND GroupKey = @GroupKey

IF @@ROWCOUNT = 0
	RETURN 0
ELSE
	RETURN 1
GO

CREATE PROCEDURE [dbo].LoadRepositoryGroupLinkByRepositoryKey (
	@RepositoryKey int
)
AS

SELECT
	rul.RepositoryKey,
	rul.GroupKey,
	rul.RoleKey
FROM RepositoryGroupLink rul JOIN [Group] g ON rul.GroupKey = g.[Key]
WHERE rul.RepositoryKey = @RepositoryKey
ORDER BY g.[Name]
GO

CREATE PROCEDURE [dbo].LoadRepositoryGroupLinkByGroupKey (
	@GroupKey int
)
AS

SELECT
	rul.RepositoryKey,
	rul.GroupKey,
	rul.RoleKey
FROM RepositoryGroupLink rul JOIN Repository r ON rul.RepositoryKey = r.[Key]
WHERE rul.GroupKey = @GroupKey
ORDER BY r.[Name]
GO

CREATE PROCEDURE [dbo].UpdateRepositoryGroupLink (
	@RepositoryKey int,
	@GroupKey int,
	@RoleKey int
)
AS

UPDATE RepositoryGroupLink
SET	RoleKey = @RoleKey
WHERE RepositoryKey = @RepositoryKey AND GroupKey = @GroupKey

IF @@ROWCOUNT = 0
	RETURN 0
ELSE
	RETURN 1
GO
