CREATE PROCEDURE [dbo].AddRepositoryUserLink (
	@RepositoryKey int,
	@UserKey int,
	@RoleKey int
)
AS

INSERT INTO RepositoryUserLink (
	RepositoryKey,
	UserKey,
	RoleKey
)
VALUES (
	@RepositoryKey,
	@UserKey,
	@RoleKey
)

GO

CREATE PROCEDURE [dbo].DeleteRepositoryUserLink (
	@RepositoryKey int,
	@UserKey int
)
AS

DELETE FROM RepositoryUserLink
WHERE RepositoryKey = @RepositoryKey AND UserKey = @UserKey

IF @@ROWCOUNT = 0
	RETURN 0
ELSE
	RETURN 1
GO

CREATE PROCEDURE [dbo].RetrieveRepositoryUserLinkByKey (
	@RepositoryKey int,
	@UserKey int
)
AS

SELECT
	RepositoryKey,
	UserKey,
	RoleKey
FROM RepositoryUserLink
WHERE RepositoryKey = @RepositoryKey AND UserKey = @UserKey

IF @@ROWCOUNT = 0
	RETURN 0
ELSE
	RETURN 1
GO

CREATE PROCEDURE [dbo].LoadRepositoryUserLinkByRepositoryKey (
	@RepositoryKey int
)
AS

SELECT
	rul.RepositoryKey,
	rul.UserKey,
	rul.RoleKey
FROM RepositoryUserLink rul JOIN [User] u ON rul.UserKey = u.[Key]
WHERE rul.RepositoryKey = @RepositoryKey
ORDER BY u.FullName
GO

CREATE PROCEDURE [dbo].LoadRepositoryUserLinkByUserKey (
	@UserKey int
)
AS

SELECT
	rul.RepositoryKey,
	rul.UserKey,
	rul.RoleKey
FROM RepositoryUserLink rul JOIN Repository r ON rul.RepositoryKey = r.[Key]
WHERE rul.UserKey = @UserKey
ORDER BY r.[Name]
GO

CREATE PROCEDURE [dbo].UpdateRepositoryUserLink (
	@RepositoryKey int,
	@UserKey int,
	@RoleKey int
)
AS

UPDATE RepositoryUserLink
SET	RoleKey = @RoleKey
WHERE RepositoryKey = @RepositoryKey AND UserKey = @UserKey

IF @@ROWCOUNT = 0
	RETURN 0
ELSE
	RETURN 1
GO
