CREATE PROCEDURE [dbo].AddReview (
	@DocumentKey int,
	@UserKey int,
	@Rating int,
	@Comments varchar(max),
	@Data varbinary(max),
	@CreationDate datetime OUT	
)
AS

SET @CreationDate = getdate()

INSERT INTO Review (
	DocumentKey,
	CreationDate,
	UserKey,	
	Rating,
	Comments,
	Data
)
VALUES (
	@DocumentKey,
	@CreationDate,
	@UserKey,
	@Rating,
	@Comments,
	@Data
)

RETURN @@IDENTITY
GO

CREATE PROCEDURE [dbo].DeleteReview (
	@Key int
)
AS

DELETE FROM Review
WHERE [Key] = @Key

IF @@ROWCOUNT = 0
	RETURN 0
ELSE
	RETURN 1
GO

CREATE PROCEDURE [dbo].RetrieveReviewByKey (
	@Key int
)
AS

SELECT
	[Key],
	DocumentKey,
	CreationDate,
	UserKey,	
	Rating,
	Comments,
	Data
FROM Review
WHERE [Key] = @Key

IF @@ROWCOUNT = 0
	RETURN 0
ELSE
	RETURN 1
GO

CREATE PROCEDURE [dbo].LoadReview (
	@DocumentKey int
)
AS

SELECT
	[Key],
	DocumentKey,
	CreationDate,
	UserKey,	
	Rating,
	Comments,
	Data
FROM Review
WHERE DocumentKey = @DocumentKey
ORDER BY CreationDate DESC
GO

CREATE PROCEDURE [dbo].UpdateReview (
	@Key int,
	@Rating int,
	@Comments varchar(max),
	@Data varbinary(max)
)
AS

UPDATE Review
SET	Rating = @Rating,
	Comments = @Comments,
	Data = @Data
WHERE [Key] = @Key

IF @@ROWCOUNT = 0
	RETURN 0
ELSE
	RETURN 1
GO
