CREATE PROCEDURE [dbo].AddUser (
	@Username varchar(30),
	@Password varchar(30),
	@IsSiteAdministrator tinyint,
	@FullName varchar(60),
	@EmailAddress varchar(128),
	@Url varchar(255)
)
AS

INSERT INTO [User] (
	Username,
	Password,
	IsSiteAdministrator,
	FullName,
	EmailAddress,
	Url
)
VALUES (
	@Username,
	@Password,
	@IsSiteAdministrator,
	@FullName,
	@EmailAddress,
	@Url
)

RETURN @@IDENTITY
GO

CREATE PROCEDURE [dbo].DeleteUser (
	@Key int
)
AS

DELETE FROM [User]
WHERE [Key] = @Key

IF @@ROWCOUNT = 0
	RETURN 0
ELSE
	RETURN 1
GO

CREATE PROCEDURE [dbo].RetrieveUserByKey (
	@Key int
)
AS

SELECT
	[Key],
	Username,
	Password,
	IsSiteAdministrator,
	FullName,
	EmailAddress,
	Url
FROM [User]
WHERE [Key] = @Key

IF @@ROWCOUNT = 0
	RETURN 0
ELSE
	RETURN 1
GO

CREATE PROCEDURE [dbo].RetrieveUserByUsername (
	@Username varchar(30)
)
AS

SELECT
	[Key],
	Username,
	Password,
	IsSiteAdministrator,
	FullName,
	EmailAddress,
	Url
FROM [User]
WHERE Username = @Username

IF @@ROWCOUNT = 0
	RETURN 0
ELSE
	RETURN 1
GO

CREATE PROCEDURE [dbo].LoadUser
AS

SELECT
	[Key],
	Username,
	Password,
	IsSiteAdministrator,
	FullName,
	EmailAddress,
	Url
FROM [User]
ORDER BY Username
GO

CREATE PROCEDURE [dbo].UpdateUser (
	@Key int,
	@Username varchar(30),
	@Password varchar(30),
	@IsSiteAdministrator tinyint,
	@FullName varchar(60),
	@EmailAddress varchar(128),
	@Url varchar(255)
)
AS

UPDATE [User]
SET	Username = @Username,
	Password = @Password,
	IsSiteAdministrator = @IsSiteAdministrator,
	FullName = @FullName,
	EmailAddress = @EmailAddress,
	Url = @Url
WHERE [Key] = @Key

IF @@ROWCOUNT = 0
	RETURN 0
ELSE
	RETURN 1
GO
