CREATE PROCEDURE [dbo].AddUserGroupLink (
	@UserKey int,
	@GroupKey int,
	@RoleKey int
)
AS

INSERT INTO UserGroupLink (
	UserKey,
	GroupKey,
	RoleKey
)
VALUES (
	@UserKey,
	@GroupKey,
	@RoleKey
)

GO

CREATE PROCEDURE [dbo].DeleteUserGroupLink (
	@UserKey int,
	@GroupKey int
)
AS

DELETE FROM UserGroupLink
WHERE UserKey = @UserKey AND GroupKey = @GroupKey

IF @@ROWCOUNT = 0
	RETURN 0
ELSE
	RETURN 1
GO

CREATE PROCEDURE [dbo].RetrieveUserGroupLinkByKey (
	@UserKey int,
	@GroupKey int
)
AS

SELECT
	UserKey,
	GroupKey,
	RoleKey
FROM UserGroupLink
WHERE UserKey = @UserKey AND GroupKey = @GroupKey

IF @@ROWCOUNT = 0
	RETURN 0
ELSE
	RETURN 1
GO

CREATE PROCEDURE [dbo].LoadUserGroupLinkByUserKey (
	@UserKey int
)
AS

SELECT
	ugl.UserKey,
	ugl.GroupKey,
	ugl.RoleKey
FROM UserGroupLink ugl JOIN [User] u ON ugl.UserKey = u.[Key]
WHERE ugl.UserKey = @UserKey
ORDER BY u.FullName
GO

CREATE PROCEDURE [dbo].LoadUserGroupLinkByGroupKey (
	@GroupKey int
)
AS

SELECT
	ugl.UserKey,
	ugl.GroupKey,
	ugl.RoleKey
FROM UserGroupLink ugl JOIN [Group] g ON ugl.GroupKey = g.[Key]
WHERE ugl.GroupKey = @GroupKey
ORDER BY g.[Name]
GO

CREATE PROCEDURE [dbo].UpdateUserGroupLink (
	@UserKey int,
	@GroupKey int,
	@RoleKey int
)
AS

UPDATE UserGroupLink
SET	UserKey = @UserKey,
	GroupKey = @GroupKey,
	RoleKey = @RoleKey
WHERE UserKey = @UserKey AND GroupKey = @GroupKey

IF @@ROWCOUNT = 0
	RETURN 0
ELSE
	RETURN 1
GO
