CREATE TABLE [dbo].[Author](
	[Key] [int] IDENTITY(1000,1) NOT NULL,
	[FullName] [varchar](60) NOT NULL,
	[Affiliation] [varchar](60) NULL
) ON [PRIMARY]

CREATE TABLE [dbo].[Document](
	[Key] [int] IDENTITY(1000,1) NOT NULL,
	[DocumentTypeKey] [int] NOT NULL,
    [RepositoryKey] [int] NOT NULL,
	[Title] [varchar](255) NOT NULL,
	[AuthorKey] [int] NOT NULL,
	[PublicationSourceKey] [int] NOT NULL,
	[PublicationDate] [datetime] NULL,
	[Abstract] [varchar] (max) NULL,
	[FileName] [varchar] (255) NOT NULL,
	[Data] [varbinary] (max) NULL,
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]

CREATE TABLE [dbo].[DocumentKeywordLink](
    [DocumentKey] [int] NOT NULL,
	[KeywordKey] [int] NOT NULL
) ON [PRIMARY]

CREATE TABLE [dbo].[DocumentType](
	[Key] [int] IDENTITY(1000,1) NOT NULL,
	[Name] [varchar](60) NOT NULL,
	[FileExtension] [varchar](10) NULL,
	[HttpContentType] [varchar](30) NOT NULL
) ON [PRIMARY]

CREATE TABLE [dbo].[Group](
	[Key] [int] IDENTITY(1000,1) NOT NULL,
	[UserKey] [int] NOT NULL,
	[Name] [varchar](60) NOT NULL	
) ON [PRIMARY]

CREATE TABLE [dbo].[Keyword](
	[Key] [int] IDENTITY(1000,1) NOT NULL,
	[Word] [varchar](50) NOT NULL	
) ON [PRIMARY]

CREATE TABLE [dbo].[PublicationSource](
	[Key] [int] IDENTITY(1000,1) NOT NULL,
	[Name] [varchar](60) NOT NULL,
	[TypeKey] [int] NOT NULL
) ON [PRIMARY]

CREATE TABLE [dbo].[PublicationSourceType](
	[Key] [int] IDENTITY(1000,1) NOT NULL,
	[Name] [varchar](60) NOT NULL
) ON [PRIMARY]

CREATE TABLE [dbo].[Review](
	[Key] [int] IDENTITY(1000,1) NOT NULL,
	[DocumentKey] [int] NOT NULL,
	[CreationDate] [datetime] NOT NULL,
	[UserKey] [int] NOT NULL,
	[Rating] [tinyint] NOT NULL,
	[Comments] [varchar] (max) NULL,
	[Data] [varbinary] (max) NULL
) ON [PRIMARY]

CREATE TABLE [dbo].[Repository](
	[Key] [int] IDENTITY(1000,1) NOT NULL,
	[UserKey] [int] NOT NULL,
	[CreationDate] [datetime] NOT NULL,
	[Name] [varchar](30) NOT NULL,
	[Description] [varchar](255) NOT NULL	
) ON [PRIMARY]

CREATE TABLE [dbo].[RepositoryUserLink](
    [RepositoryKey] [int] NOT NULL,
	[UserKey] [int] NOT NULL,
	[RoleKey] [int] NOT NULL
) ON [PRIMARY]

CREATE TABLE [dbo].[RepositoryGroupLink](
    [RepositoryKey] [int] NOT NULL,
	[GroupKey] [int] NOT NULL,
	[RoleKey] [int] NOT NULL
) ON [PRIMARY]

CREATE TABLE [dbo].[Role](
	[Key] [int] IDENTITY(1000,1) NOT NULL,
	[Name] [varchar] (30) NOT NULL,
	[Description] [varchar](255) NULL
) ON [PRIMARY]

CREATE TABLE [dbo].[User](
	[Key] [int] IDENTITY(1000,1) NOT NULL,
	[Username] [varchar](30) NOT NULL,
	[Password] [varchar] (30) NOT NULL,
	[IsSiteAdministrator] [tinyint] NOT NULL,
	[FullName] [varchar](60) NULL,
	[EmailAddress] [varchar](128) NULL,
	[URL] [varchar](255) NULL		
) ON [PRIMARY]

CREATE TABLE [dbo].[UserGroupLink](
	[UserKey] [int] NOT NULL,
	[GroupKey] [int] NOT NULL,
	[RoleKey] [int] NOT NULL
) ON [PRIMARY]