﻿using System;
using System.Web;
using System.Web.UI.WebControls;
using Bespoke.ResearchExpert.Data;
using Bespoke.Common.Data;

public partial class AddPublicationSourceTypeAdmin : PageBase
{
    protected string PublicationSourceTypeName
    {
        get
        {
            return mNameTextBox.Text.Trim();
        }
        set
        {
            mNameTextBox.Text = value.Trim();
        }
    }

    protected override void OnPageLoad()
    {
        mUser = GetSessionValue<UserRecord>(SessionVariable.User);
        if (mUser == null)
        {
            Response.Redirect(GetApplicationValue<string>(ApplicationVariable.LoginPage), true);
        }
        else if (mUser.IsSiteAdministrator == false)
        {
            Response.Redirect(GetApplicationValue<string>(ApplicationVariable.MainPage), true);
        }
        else
        {
            mLoginLabel.Text = mUser.Username + " logged in (<a href=\"" + GetApplicationValue<string>(ApplicationVariable.LogoutPage) + "\">Logout</a>)";
        }

        mStatusLabel.Visible = false;
        mNameTextBox.Focus();
    }

    #region Event Handlers

    protected void mAddButton_Click(object sender, EventArgs e)
    {
        try
        {
            PublicationSourceTypeRecord publicationSourceTypeName;
            if (PublicationSourceTypeManager.RetrievePublicationSourceTypeByName(PublicationSourceTypeName, out publicationSourceTypeName))
            {
                mStatusLabel.Visible = true;
                mStatusLabel.Text = string.Format("Could not add publication source type. Existing publication source type [{0}] found.", PublicationSourceTypeName);
            }
            else
            {
                mStatusLabel.Visible = false;
                PublicationSourceTypeManager.AddPublicationSourceType(new PublicationSourceTypeRecord(SqlDataProvider.DefaultKey, PublicationSourceTypeName));

                Response.Redirect(GetApplicationValue<string>(ApplicationVariable.SiteAdministrationPage) + "?SelectedTab=" + SiteAdministrationTabs.PublicationSourceTypes.ToString(), true);
            }
        }
        catch (Exception ex)
        {
            mStatusLabel.Visible = true;
            mStatusLabel.Text = ex.Message;
        }
    }

    protected void mCancelButton_Click(object sender, EventArgs e)
    {
        Response.Redirect(GetApplicationValue<string>(ApplicationVariable.SiteAdministrationPage) + "?SelectedTab=" + SiteAdministrationTabs.PublicationSourceTypes.ToString(), true);
    }

    #endregion

    private UserRecord mUser;
}
