﻿using System;
using System.Web;
using Bespoke.ResearchExpert.Data;

public partial class AuthorView : PageBase
{
    public int AuthorKey
    {
        get
        {
            return mAuthorKey;
        }
        set
        {
            mAuthorKey = value;
        }
    }

    protected override void OnPageLoad()
    {
        UserRecord user = GetSessionValue<UserRecord>(SessionVariable.User);
        if (user == null)
        {
            Response.Redirect(GetApplicationValue<string>(ApplicationVariable.LoginPage), true);
        }
        else
        {
            mLoginLabel.Text = user.Username + " logged in (<a href=\"" + GetApplicationValue<string>(ApplicationVariable.LogoutPage) + "\">Logout</a>)";
        }

        if (int.TryParse(Request.Params["AuthorKey"], out mAuthorKey) == false)
        {
            Response.Redirect(GetApplicationValue<string>(ApplicationVariable.ErrorPage) + "?ErrorMessage=Invalid Author Key", true);
        }

        AuthorRecord author;
        if (AuthorManager.RetrieveAuthorByKey(mAuthorKey, out author) == false)
        {
            Response.Redirect(GetApplicationValue<string>(ApplicationVariable.ErrorPage) + "?ErrorMessage=Invalid Author Key", true);
        }

        mNameLabel.Text = author.FullName;
        mAffiliationLabel.Text = author.Affiliation;

        //TODO
        //mDocumentControl.Repository = repository;
    }

    private int mAuthorKey;
}
