﻿using System;
using System.IO;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Bespoke.ResearchExpert.Data;

public partial class DocumentTypeAdminControl : ControlBase
{
    /// <summary>
    /// Called when [page load].
    /// </summary>
    protected override void OnPageLoad()
    {
        DocumentTypeRecordList documentTypes = DocumentTypeManager.LoadDocumentType();
        if (documentTypes.Count == 0)
        {
            TableCell cell = new TableCell();
            cell.ColumnSpan = 3;
            cell.Text = "<< No Document Types Found >>";

            TableRow row = new TableRow();
            row.Cells.Add(cell);
            mDocumentTypeTable.Rows.Add(row);
        }
        else
        {            
            bool ToggleColor = false;

            foreach (DocumentTypeRecord documentType in documentTypes)
            {
                ToggleColor = !ToggleColor;
                string cssClass = (ToggleColor ? CssCellStyle : CssCellStyleAlt);
                TableRow row = new TableRow();
                mDocumentTypeTable.Rows.Add(row);

                TableCell cell = new TableCell();
                row.Cells.Add(cell);
                cell.CssClass = cssClass;
                cell.Text = string.Format("<a class=\"DocumentTypeAdminItem\" href=\"EditDocumentType.aspx?DocumentTypeKey={0}\">{1}</a>", documentType.Key.ToString(), documentType.Name);

                cell = new TableCell();
                row.Cells.Add(cell);
                cell.CssClass = cssClass;
                cell.Text = documentType.FileExtension;

                cell = new TableCell();
                row.Cells.Add(cell);
                cell.CssClass = cssClass;
                cell.Text = documentType.HttpContentType;
            }
        }
    }

    private const string CssCellStyle = "DocumentTypeAdminControl";
    private const string CssCellStyleAlt = "DocumentTypeAdminControlAlt";
}
