﻿using System;
using System.Web;
using System.Web.UI.WebControls;
using Bespoke.ResearchExpert.Data;

public partial class GroupControl : ControlBase
{
    /// <summary>
    /// Called when [page load].
    /// </summary>
    protected override void OnPageLoad()
    {
        UserRecord user = GetSessionValue<UserRecord>(SessionVariable.User);
        if (user != null)
        {
            GroupRecordList groups = GroupManager.LoadGroupByUserKey(user.Key);

            if (groups.Count == 0)
            {
                TableCell cell = new TableCell();
                cell.ColumnSpan = 3;
                cell.Text = "<< No Groups Found >>";

                TableRow row = new TableRow();
                row.Cells.Add(cell);

                mGroupTable.Rows.Add(row);
            }
            else
            {
                bool ToggleColor = false;

                foreach (GroupRecord group in groups)
                {
                    ToggleColor = !ToggleColor;
                    string cssClass = (ToggleColor ? CssCellStyle : CssCellStyleAlt);
                    TableRow row = new TableRow();                    

                    TableCell cell = new TableCell();
                    cell.CssClass = cssClass;
                    cell.Text = group.Name;
                    row.Cells.Add(cell);

                    mGroupTable.Rows.Add(row);
                }
            }
        }
    }

    #region Event Handlers

    protected void mDeleteButton_Click(object sender, EventArgs e)
    {
        //TODO
    }

    #endregion

    private const string CssCellStyle = "GroupControl";
    private const string CssCellStyleAlt = "GroupControlAlt";

}
