﻿using System;
using System.IO;
using System.Web;
using System.Web.UI.WebControls;
using Bespoke.ResearchExpert.Data;

public partial class MenuControl : ControlBase
{
    /// <summary>
    /// Called when [page load].
    /// </summary>
    protected override void OnPageLoad()
    {
        mHomeLink.NavigateUrl = Path.Combine(Request.ApplicationPath, GetApplicationValue<string>(ApplicationVariable.MainPage));
        mSiteAdminLink.NavigateUrl = Path.Combine(Request.ApplicationPath, GetApplicationValue<string>(ApplicationVariable.SiteAdministrationPage));

        UserRecord user = GetSessionValue<UserRecord>(SessionVariable.User);
        mSiteAdminLink.Visible = (user != null && user.IsSiteAdministrator);
    }
}
