﻿using System;
using System.Web;
using Bespoke.ResearchExpert.Data;

public partial class _Default : PageBase
{
    protected override void OnPageLoad()
    {
        UserRecord user = GetSessionValue<UserRecord>(SessionVariable.User);
        if (user != null)
        {
            Response.Redirect(GetApplicationValue<string>(ApplicationVariable.MainPage), true);
        }
    }

    #region Event Handlers

    protected void mLoginControl_LoggingIn(object sender, EventArgs e)
    {
        UserRecord user = null;

        if ((mLoginControl.Username == String.Empty) || (mLoginControl.Password == String.Empty))
        {
            mLoginControl.StatusLabel = "Please specify username and password.";
            SaveSessionValue(SessionVariable.User, null);
        }
        else
        {
            if (UserManager.RetrieveUserByUsername(mLoginControl.Username, out user) == false)
            {
                mLoginControl.StatusLabel = "Invalid Username/Password";
                SaveSessionValue(SessionVariable.User, null);
            }
            else
            {
                if (user.Password != mLoginControl.Password)
                {
                    mLoginControl.StatusLabel = "Invalid Username/Password";
                    SaveSessionValue(SessionVariable.User, null);
                }
                else
                {
                    SaveSessionValue(SessionVariable.User, user);
                    mLoginControl.StatusLabel = "Welcome " + user.FullName;
                }
            }
        }

        if (GetSessionValue<UserRecord>(SessionVariable.User) != null)
        {
            mLoginControl.StatusLabel = "Login Successful!";
            Response.Redirect(GetApplicationValue<string>(ApplicationVariable.MainPage), true);
        }
    }

    #endregion
}
