﻿using System;
using System.Web;
using Bespoke.ResearchExpert.Data;

public partial class DocumentView : PageBase
{
    protected override void OnPageLoad()
    {
        UserRecord user = GetSessionValue<UserRecord>(SessionVariable.User);
        if (user == null)
        {
            Response.Redirect(GetApplicationValue<string>(ApplicationVariable.LoginPage), true);
        }
        else
        {
            mLoginLabel.Text = user.Username + " logged in (<a href=\"" + GetApplicationValue<string>(ApplicationVariable.LogoutPage) + "\">Logout</a>)";
        }

        int repositoryKey;
        if (int.TryParse(Request.Params["RepositoryKey"], out repositoryKey))
        {
            RepositoryRecord repository;
            if (RepositoryManager.RetrieveRepositoryByKey(repositoryKey, out repository) == false)
            {
                Response.Redirect(GetApplicationValue<string>(ApplicationVariable.ErrorPage) + "?ErrorMessage=Invalid Repository Key", true);
            }

            SaveSessionValue(SessionVariable.Repository, repository);
            mRepositoryLabel.Text = repository.Name;
        }
        else
        {
            RepositoryRecord repository = GetSessionValue<RepositoryRecord>(SessionVariable.Repository);
            if (repository == null)
            {
                Response.Redirect(GetApplicationValue<string>(ApplicationVariable.ErrorPage) + "?ErrorMessage=Repository Not Set", true);
            }
        }
    }
}
