﻿using System;
using System.Web;
using Bespoke.ResearchExpert.Data;

public partial class ErrorPage : PageBase
{
    public string ErrorMessage
    {
        get
        {
            return mErrorMessage;
        }
        set
        {
            mErrorMessage = value;
        }
    }

    protected override void OnPageLoad()
    {
        UserRecord user = GetSessionValue<UserRecord>(SessionVariable.User);
        if (user == null)
        {
            Response.Redirect(GetApplicationValue<string>(ApplicationVariable.LoginPage), true);
        }
        else
        {
            mLoginLabel.Text = user.Username + " logged in (<a href=\"" + GetApplicationValue<string>(ApplicationVariable.LogoutPage) + "\">Logout</a>)";
        }

        mErrorMessage = Request.Params["ErrorMessage"];
    }

    private string mErrorMessage;
}
