﻿using System;
using System.Web;
using Bespoke.ResearchExpert.Data;

public partial class PublicationSourceView : PageBase
{
    public int PublicationSourceKey
    {
        get
        {
            return mPublicationSourceKey;
        }
        set
        {
            mPublicationSourceKey = value;
        }
    }

    protected override void OnPageLoad()
    {
        UserRecord user = GetSessionValue<UserRecord>(SessionVariable.User);
        if (user == null)
        {
            Response.Redirect(GetApplicationValue<string>(ApplicationVariable.LoginPage), true);
        }
        else
        {
            mLoginLabel.Text = user.Username + " logged in (<a href=\"" + GetApplicationValue<string>(ApplicationVariable.LogoutPage) + "\">Logout</a>)";
        }

        if (int.TryParse(Request.Params["PublicationSourceKey"], out mPublicationSourceKey) == false)
        {
            Response.Redirect(GetApplicationValue<string>(ApplicationVariable.ErrorPage) + "?ErrorMessage=Invalid Publication Source Key", true);
        }

        PublicationSourceRecord publicationSource;
        if (PublicationSourceManager.RetrievePublicationSourceByKey(mPublicationSourceKey, out publicationSource) == false)
        {
            Response.Redirect(GetApplicationValue<string>(ApplicationVariable.ErrorPage) + "?ErrorMessage=Invalid Publication Source Key", true);
        }

        PublicationSourceTypeRecord publicationSourceType;
        if (PublicationSourceTypeManager.RetrievePublicationSourceTypeByKey(publicationSource.TypeKey, out publicationSourceType) == false)
        {
            Response.Redirect(GetApplicationValue<string>(ApplicationVariable.ErrorPage) + "?ErrorMessage=Invalid Publication Source Type", true);
        }

        mNameLabel.Text = publicationSource.Name;
        mTypeLabel.Text = publicationSourceType.Name;
    }

    private int mPublicationSourceKey;
}
