﻿using System;
using System.Web;
using Bespoke.ResearchExpert.Data;

public partial class SiteAdministration : PageBase
{
    protected override void OnPageLoad()
    {
        mUser = GetSessionValue<UserRecord>(SessionVariable.User);
        if (mUser == null)
        {
            Response.Redirect(GetApplicationValue<string>(ApplicationVariable.LoginPage), true);
        }
        else
        {
            mLoginLabel.Text = mUser.Username + " logged in (<a href=\"" + GetApplicationValue<string>(ApplicationVariable.LogoutPage) + "\">Logout</a>)";
        }

        if (string.IsNullOrEmpty(Request.Params["SelectedTab"]) == false)
        {
            mSelectedTabField.Value = Request.Params["SelectedTab"];
        }

        if (string.IsNullOrEmpty(mSelectedTabField.Value))
        {
            mTabContainer.ActiveTabIndex = (int)SiteAdministrationTabs.Users;
            mSelectedTabField.Value = SiteAdministrationTabs.Users.ToString();
        }
        else
        {
            SiteAdministrationTabs selectedTab = (SiteAdministrationTabs)Enum.Parse(typeof(SiteAdministrationTabs), mSelectedTabField.Value);
            mTabContainer.ActiveTabIndex = (int)selectedTab;
        }
    }

    protected void mTabContainer_ActiveTabChanged(object sender, EventArgs e)
    {
        mSelectedTabField.Value = ((SiteAdministrationTabs)mTabContainer.ActiveTabIndex).ToString();
    }

    private UserRecord mUser;
}
